/* pam_auth.c -- PAM authentication */

#include <stdio.h>
#include <stdlib.h>

#include "pam_private.h"

int pam_authenticate(pam_handle_t *pamh, int flags)
{
    int retval;
    
    IF_NO_PAMH("pam_authenticate",pamh,PAM_SYSTEM_ERR);

    retval = _pam_dispatch(pamh, flags, PAM_AUTHENTICATE);

    return retval;
}

int pam_setcred(pam_handle_t *pamh, int flags)
{
    IF_NO_PAMH("pam_setcred",pamh,PAM_SYSTEM_ERR);

    if (! flags) {
	flags = PAM_CRED_ESTABLISH;
    }

    return _pam_dispatch(pamh, flags, PAM_SETCRED);
}
