
/* pam_permit module */

/*
 * $Id: pam_deny.c,v 1.1 1996/03/16 17:47:36 morgan Exp $
 *
 * Written by Andrew Morgan <morgan@physics.ucla.edu> 1996/3/11
 *
 * $Log: pam_deny.c,v $
 * Revision 1.1  1996/03/16 17:47:36  morgan
 * Initial revision
 *
 */

#include <security/pam_modules.h>

/* --- authentication management functions --- */

int pam_sm_authenticate(pam_handle_t *pamh,int flags,int argc
			,const char **argv)
{
     return PAM_AUTH_ERR;
}

int pam_sm_setcred(pam_handle_t *pamh,int flags,int argc
		   ,const char **argv)
{
     return PAM_CRED_UNAVAIL;
}

/* --- account management functions --- */

int pam_sm_acct_mgmt(pam_handle_t *pamh,int flags,int argc
		     ,const char **argv)
{
     return PAM_ACCT_EXPIRED;
}

/* --- password management --- */

int pam_sm_chauthtok(pam_handle_t *pamh,int flags,int argc
		     ,const char **argv)
{
     return PAM_AUTHTOK_ERR;
}

/* --- session management --- */

int pam_sm_open_session(pam_handle_t *pamh,int flags,int argc
			,const char **argv)
{
    return PAM_SYSTEM_ERR;
}

int pam_sm_close_session(pam_handle_t *pamh,int flags,int argc
			 ,const char **argv)
{
     return PAM_SYSTEM_ERR;
}

/* end of module definition */
