/* pam_test module */

#include <stdlib.h>
#include <stdio.h>

#include <security/pam_modules.h>

void _pam_report(const char *name, int flags, int argc, const char **argv);

void _pam_report(const char *name, int flags, int argc, const char **argv)
{
    fprintf(stderr, "CALLED: %s\n", name);
    fprintf(stderr, "FLAGS : %d\n", flags);
    fprintf(stderr, "ARGV  :");
    while (argc--) {
	fprintf(stderr, " \"%s\"", *argv++);
    }
    fprintf(stderr, "\n");
}

int pam_sm_authenticate(pam_handle_t *pamh, int flags,
			int argc, const char **argv)
{
    _pam_report("pam_sm_authenticate", flags, argc, argv);
    return PAM_SUCCESS;
}

int pam_sm_setcred(pam_handle_t *pamh, int flags,
		   int argc, const char **argv)
{
    _pam_report("pam_sm_setcred", flags, argc, argv);
    return PAM_SUCCESS;
}

int pam_sm_acct_mgmt(pam_handle_t *pamh, int flags,
		     int argc, const char **argv)
{
    _pam_report("pam_sm_acct_mgmt", flags, argc, argv);
    return PAM_SUCCESS;
}

int pam_sm_open_session(pam_handle_t *pamh, int flags,
			int argc, const char **argv)
{
    _pam_report("pam_sm_open_session", flags, argc, argv);
    return PAM_SUCCESS;
}

int pam_sm_close_session(pam_handle_t *pamh, int flags,
			 int argc, const char **argv)
{
    _pam_report("pam_sm_close_session", flags, argc, argv);
    return PAM_SUCCESS;
}

int pam_sm_chauthtok(pam_handle_t *pamh, int flags,
		     int argc, const char **argv)
{
    _pam_report("pam_sm_chauthtok", flags, argc, argv);
    return PAM_SUCCESS;
}

