/* $Header: /home/morgan/pam/Linux-PAM-0.21/modules/pam_unix/RCS/pam_unix_auth.c,v 1.1 1996/03/09 09:10:57 morgan Exp $ */

/*
 * Copyright Alexander O. Yuriev, 1996.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, and the entire permission notice in its entirety,
 *    including the disclaimer of warranties.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. The name of the author may not be used to endorse or promote
 *    products derived from this software without specific prior
 *    written permission.
 * 
 * ALTERNATIVELY, this product may be distributed under the terms of
 * the GNU Public License, in which case the provisions of the GPL are
 * required INSTEAD OF the above restrictions.  (This clause is
 * necessary due to a potential bad interaction between the GPL and
 * the restrictions contained in a BSD-style copyright.)
 * 
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
 * SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
 * STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
 * OF THE POSSIBILITY OF SUCH DAMAGE.
 */
 
/* 
 * $Log: pam_unix_auth.c,v $
 * Revision 1.1  1996/03/09 09:10:57  morgan
 * Initial revision
 *
 *
 */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <pwd.h>
#ifndef LINUX    /* AGM added this as of 0.2 */
#include <security/pam_appl.h>
#endif           /* ditto */
#include <security/pam_modules.h>
#include <unistd.h>

static char rcsid[] = "$Id: pam_unix_auth.c,v 1.1 1996/03/09 09:10:57 morgan Exp $ alex@bach.cis.temple.edu";

static int _pam_auth_unix(	pam_handle_t *pamh, 
				int flags, int argc, 
				const char **argv
			);


/* _pam_auth_unix(): Unix /etc/passwd authentication */

static int _pam_auth_unix(	pam_handle_t *pamh,
				int flags, 
				int argc,
				const char **argv	) 
{
	struct passwd *pw;
	char *name, *p, *pp;

	pam_get_item( pamh, PAM_USER, (void*) &name );
	pam_get_item( pamh, PAM_AUTHTOK, (void*) &p );
	if ( !( p && name ) )
		return	PAM_CONV_ERR;

	pw = getpwnam ( name );
	if ( !pw )
		return	PAM_USER_UNKNOWN;

	pp = crypt( p, p );
	if ( strcmp( pp, pw->pw_passwd ) == 0 ) 
		return	PAM_SUCCESS;

  	return PAM_AUTH_ERR;

}


/* Completed sections */


int pam_sm_authenticate(	pam_handle_t *pamh, 
				int flags,
				int argc, 
				const char **argv	)
{
	return _pam_auth_unix( pamh, flags, argc, argv	);
}

/* Not completed sections */


int pam_sm_setcred( pam_handle_t *pamh, 
		    int flags,
		    int argc, 
		    const char **argv)
{
    return PAM_SUCCESS;
}

int pam_sm_acct_mgmt(pam_handle_t *pamh, int flags,
		     int argc, const char **argv)
{
    return PAM_SUCCESS;
}

